---
stages:
  - unit_test
  - test

variables:
  COVERAGE_FILE: pytest-coverage.xml
  CC_TEST_REPORTER_ID: ""
  PYTHON_VERSIONS: "v3.7 v3.8"

.pytest:
  stage: unit_test
  # yamllint disable rule:line-length
  before_script:
    - >
      if [ -n "${CC_TEST_REPORTER_ID}" ]; then
        curl -L https://codeclimate.com/downloads/test-reporter/test-reporter-latest-linux-amd64 > ./cc-test-reporter
        chmod +x ./cc-test-reporter
        ./cc-test-reporter before-build
      else
        echo "no code climate coverage test id, not launching"
      fi
    - >
      if [ -e requirements.txt ]; then
        pip install --user -r requirements.txt
      fi
  # yamllint enable rule:line-length
  script:
    - python setup.py test
    - >
      if [ -n "${CC_TEST_REPORTER_ID}" ]; then
        cp ${COVERAGE_FILE} coverage.xml
        ./cc-test-reporter after-build -t coverage.py || true
      fi
  artifacts:
    paths:
      - coverage
    reports:
      junit: pytest-*.xml
  except:
    variables:
      - $PYTEST_DISABLED
      - $JOBS_DISABLED

pytest:3.7:
  extends: .pytest
  image: python:3.7
  only:
    variables:
      - $PYTHON_VERSIONS =~ /v3.7/

pytest:3.8:
  extends: .pytest
  image: python:3.8
  only:
    variables:
      - $PYTHON_VERSIONS =~ /v3.8/

pytest:3.9:
  extends: .pytest
  image: python:3.9
  only:
    variables:
      - $PYTHON_VERSIONS =~ /v3.9/

pytest:3.9-alpine:
  extends: .pytest
  image: python:3.9-alpine
  only:
    variables:
      - $PYTHON_VERSIONS =~ /v3.9-alpine/

pytest:3.10:
  extends: .pytest
  image: python:3.10
  only:
    variables:
      - $PYTHON_VERSIONS =~ /v3.10/
